﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="WebForm1.aspx.cs" Inherits="TestGrid.WebForm1" %>

<%@ Register Assembly="Syncfusion.EJ.Web, Version=13.3450.0.7, Culture=neutral, PublicKeyToken=3d67ed1f87d44c89" Namespace="Syncfusion.JavaScript.Web" TagPrefix="ej" %>
<%@ Register Assembly="Syncfusion.EJ, Version=13.3450.0.7, Culture=neutral, PublicKeyToken=3d67ed1f87d44c89" Namespace="Syncfusion.JavaScript.Models" TagPrefix="ej" %>

<%@ Register TagPrefix="ej" Namespace="Syncfusion.JavaScript.Models" Assembly="Syncfusion.EJ" %>
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
     <link href="http://cdn.syncfusion.com/13.3.0.7/js/web/flat-lime/ej.web.all.min.css" rel="stylesheet" />

    <script src="http://code.jquery.com/jquery-2.1.4.min.js"></script>
    <script src="http://cdn.syncfusion.com/js/assets/external/jquery.globalize.min.js"></script>
    <script src="http://cdn.syncfusion.com/js/assets/external/jquery.easing.1.3.min.js"></script>
    <script src="http://cdn.syncfusion.com/js/assets/external/jsrender.min.js"></script>
    <script src="http://cdn.syncfusion.com/13.3.0.7/js/web/ej.web.all.min.js"></script>
    <script src="http://cdn.syncfusion.com/13.3.0.7/js/common/ej.webform.min.js"></script>
</head>
<body>

    <form id="form1" runat="server">
        <asp:ScriptManager runat="server"></asp:ScriptManager>
        <script type="text/template" id="template">
            <b>Order Details</b>
            <table cellspacing="10">
                <tr>
                    <td style="text-align: right;">ID</td>
                    <td style="text-align: left">
                        <input id="ID" name="ID" value="{{: ID}}" disabled="disabled" class="e-field e-ejinputtext valid e-disable"
                            style="text-align: right; width: 116px; height: 28px" />
                    </td>
                    <td style="text-align: right;">First Name</td>
                    <td style="text-align: left">
                        <input id="FirstName" name="FirstName" value="{{: FirstName}}" class="e-field e-ejinputtext valid"
                            style="width: 116px; height: 28px" />
                    </td>
                </tr>
                <tr>
                    <td style="text-align: right;">LastName</td>
                    <td style="text-align: left">
                        <input id="LastName" name="LastName" value="{{: LastName}}" class="e-field e-ejinputtext valid"
                            style="width: 116px; height: 28px" />
                    </td>
                    <td style="text-align: right;">City</td>
                    <td style="text-align: left">
                        <input id="Addresses.0.City" name="Addresses.0.City" value="{{:((#data['Addresses'] || {})['0'] || {})['City']}}" class="e-field e-ejinputtext valid"
                            style="width: 116px; height: 28px" />
                    </td>
                </tr>
                <tr>
                    <td> DDL with TreeView</td>
                    <td>
                        <input type="text" id="drpdwn" />
                        <div id="target">
                            <ul>
                                <li>
                                    <!--Treeview Template begin-->
                                    <div id="control-wrap" class="wrapper">
                                        <div id="treeView">
                                        </div>
                                    </div>
                                    <!--Treeview Template end-->
                                </li>
                            </ul>
                        </div>
                        </td>
                        <td><input type="text" id="drp2" /></td>
                    </tr>
            </table>
        </script>
        <br />
        <h3> Click to edit row to get the dialog template</h3>
        <div style="width:600px">
            <ej:Grid ID="Grid" runat="server">
                <ClientSideEvents ActionComplete="actionComplete" />
                <Columns>
                    <ej:Column Field="ID" HeaderText="ID" IsPrimaryKey="true" Visible="false">
                    </ej:Column>
                    <ej:Column Field="FirstName" HeaderText="First Name">
                    </ej:Column>
                    <ej:Column Field="LastName" HeaderText="Last Name">
                    </ej:Column>
                    <ej:Column Field="Addresses.0.Country" HeaderText="Address">
                    </ej:Column>
                </Columns>
                <EditSettings AllowEditing="True" AllowAdding="True" AllowDeleting="True" EditMode="DialogTemplate" DialogEditorTemplateID="#template"></EditSettings>
                <ToolbarSettings ShowToolbar="True" ToolbarItems="add,edit,delete,update,cancel"></ToolbarSettings>
            </ej:Grid>
        </div>
        <br />
       
        <script type="text/javascript">
            var localData = [
           { id: 1, name: "Mail", hasChild: true, expanded: true },
           { id: 2, pid: 1, name: "Inbox", hasChild: true },
           { id: 3, pid: 2, name: "Development" },
           { id: 4, pid: 2, name: "Supports" },
           { id: 5, pid: 2, name: "HR Team" },
           { id: 6, pid: 1, name: "Drafts", hasChild: true },
           { id: 7, pid: 6, name: "Support template" },
           { id: 8, pid: 6, name: "Personal" },
           { id: 9, pid: 1, name: "Sent items", hasChild: true },
           { id: 10, pid: 9, name: "Support" },
           { id: 11, pid: 1, name: "Deleted", hasChild: true },
           { id: 12, pid: 1, name: "Junk mail", hasChild: true },
           { id: 13, pid: 1, name: "Personal", hasChild: true },
           { id: 14, pid: 13, name: "HR Team" },
           { id: 15, pid: 13, name: "My Works"},
           { id: 16, pid: 13, name: "Login Details" },

           { id: 17, name: "Calendar", hasChild: true },
           { id: 18, pid: 17, name: "My Calendar" },
           { id: 19, pid: 17, name: "Team" },
           { id: 20, pid: 17, name: "Others" },

           { id: 21, name: "Notes", hasChild: true },
           { id: 22, pid: 21, name: "My Reference" },
           { id: 23, pid: 21, name: "Team Meeting" },
           { id: 24, pid: 21, name: "Others" },

           { id: 25, name: "Contacts", hasChild: true },
           { id: 26, pid: 25, name: "Suggested " },
           { id: 27, pid: 25, name: "My Team" },
           { id: 28, pid: 25, name: "Others" }
            ];
            var mouseClick = ej.DropDownList.prototype._OnMouseClick;
            var mouseEnter = ej.DropDownList.prototype._OnMouseEnter;
            var mouseLeave = ej.DropDownList.prototype._OnMouseLeave;
            var keyup = ej.DropDownList.prototype._OnKeyUp;
            var keydown = ej.DropDownList.prototype._OnKeyDown;
                    ej.DropDownList.prototype._OnMouseClick = function (e) { }
                    ej.DropDownList.prototype._OnMouseEnter = function (e) { }
                    ej.DropDownList.prototype._OnMouseLeave = function (e) { }
                    ej.DropDownList.prototype._OnKeyUp = function (e) { }
                    ej.DropDownList.prototype._OnKeyDown = function (e) { }
            var initialLoad;
            function actionComplete(args) {
                initialLoad = true;
                var data = [{ text: "name 1", value: 1 }, { text: "name 2", value: 2 }, { text: "name 3", value: 3 }];
                if ((args.requestType == "beginedit" || args.requestType == "add")) {
                    $(".gridform input:eq(4)").ejDropDownList({
                        targetID: "target",
                        popupHeight: "280px",
                        watermarkText: "Select an item",
                        width: "300px",
                    });
                    ej.DropDownList.prototype._OnMouseClick = mouseClick;
                    ej.DropDownList.prototype._OnMouseEnter = mouseEnter;
                    ej.DropDownList.prototype._OnMouseLeave = mouseLeave;
                    ej.DropDownList.prototype._OnKeyUp = keyup;
                    ej.DropDownList.prototype._OnKeyDown = keydown;
                    $("#drp2").ejDropDownList({
                        dataSource: data,
                        width: "300px",
                        select: function () { console.log("hi")}
                    });
                    $("#treeView").ejTreeView({
                        fields: { id: "id", parentId: "pid", text: "name", hasChild: "hasChild", dataSource: localData, expanded: "expanded", isChecked: "isChecked", imageUrl: "img" },
                        showCheckbox: true,
                        width: "100%",                        
                        nodeCheck: onNodeCheck,
                        nodeUncheck: onNodeUnCheck,
                        nodeExpand: checkScroll,
                        nodeCollapse: checkScroll,
                        nodeSelect: onNodeSelect
                    });
                }
                treeobj = $("#treeView").data("ejTreeView");
                drpdwnobj = $("#drpdwn").data("ejDropDownList");

                function onNodeSelect(args) {

                    if (args.currentElement != undefined) {
                        if (!$(args.currentElement.children().find("input.nodecheckbox")).hasClass("checked"))
                            this.checkNode(args.currentElement);
                        else
                            this.uncheckNode(args.currentElement);
                    }
                }
                function checkScroll(args) {
                    if (initialLoad == true) {
                        drpdwnobj.hidePopup();
                        initialLoad = false;
                    }
                    else {
                        var scrolpos = drpdwnobj.scrollerObj.model.scrollTop;
                        drpdwnobj._refreshScroller();
                        drpdwnobj.popupList.css("display", "block");
                        drpdwnobj.scrollerObj.setModel({ "scrollTop": scrolpos });
                    }
                }
                function onNodeCheck(args) {
                    var matched = 0;
                    var browser = ej.browserInfo();
                    if (!(args.currentElement.children("ul"))) {
                        var data = drpdwnobj.getValue().split(",");
                        for (i = 0; i < data.length; i++) {
                            if (data[i] == args.value) {
                                matched = 1;
                                break;
                            }
                        }
                        if (!matched)
                            drpdwnobj._addText((args.value));
                    }
                    else {
                        var data = drpdwnobj.getValue().split(",");
                        var checkeditems = treeobj.getCheckedNodes();
                        for (i = 0; i < checkeditems.length; i++) {
                            if (browser.name == "msie" && parseInt(browser.version) == 8) {
                                if (((checkeditems[i] != undefined) && (data[i] != checkeditems[i].innerText)) && ($(checkeditems[i]).children("ul.e-treeview-ul")[0] == undefined)) {
                                    drpdwnobj._addText(checkeditems[i].innerText);
                                }
                            }
                            else {
                                if (((checkeditems[i] != undefined) && (data[i] != checkeditems[i].textContent)) && ($(checkeditems[i]).children("ul.e-treeview-ul")[0] == undefined)) {
                                    drpdwnobj._addText(checkeditems[i].textContent);
                                }
                            }
                        } drpdwnobj.model.value = drpdwnobj.element.val();
                        drpdwnobj.model.text = drpdwnobj.element.val();
                    }

                }
                //Function triggers while uncheck the checkbox in tree view and it removes the unchecked item text from dropdownlist value
                function onNodeUnCheck(args) {
                    var browser = ej.browserInfo();
                    if (!(args.currentElement.children("ul")))
                        drpdwnobj._removeText((args.value));
                    else {
                        var data = drpdwnobj.getValue().split(",");
                        var checkeditems = treeobj.getCheckedNodes();
                        drpdwnobj.clearText();
                        for (i = 0; i < checkeditems.length; i++) {
                            if (browser.name == "msie" && parseInt(browser.version) == 8) {
                                if (((checkeditems[i] != undefined) && (data[i] != checkeditems[i].innerText)) && ($(checkeditems[i]).children("ul.e-treeview-ul")[0] == undefined)) {
                                    drpdwnobj._addText(checkeditems[i].innerText);
                                }
                            }
                            else {
                                if (((checkeditems[i] != undefined) && (data[i] != checkeditems[i].textContent)) && ($(checkeditems[i]).children("ul.e-treeview-ul")[0] == undefined)) {
                                    drpdwnobj._addText(checkeditems[i].textContent);
                                }
                            }
                        } drpdwnobj.model.value = drpdwnobj.element.val();
                        drpdwnobj.model.text = drpdwnobj.element.val();
                    }
                }
            }
        </script>
    </form>
    <style type="text/css">
        div#drpdwn_popup {
            overflow-y: scroll;
        }
    </style>

</body>
</html>
